
{Feedback Servo Demo}

CON
        _clkmode = xtal1 + pll16x        'Standard clock mode 
        _xinfreq = 5_000_000             '* crystal frequency = 80 MHz
  
        CP0 = 17, FP0 = 8, Servo0 = 0    'servo zero pins, name
        CP1 = 16, FP1 = 9, Servo1 = 1    'servo one:  Make these zeroes for single servo case
        CP2 = 15, FP2 = 10, Servo2 = 2   'make these zeroes for servos
        CP3 = 14, FP3 = 11, Servo3 = 3   'that do not exist
        #0, CW, CCW                      'directions for velocity

VAR
  byte  Cog
  word  commanded            'commanded angle
  byte  angle                'which of four cases for full scale changes
  long  random               'chooses random angle
  word  rcount                'counts random positionings
  word  Cmnded[4]             'commanded angle
  byte  currentservo          'used in random positioning              
  byte  TheServo
  byte  LastServo
  word  Servo2Theta           'used in final demo
  
OBJ
  pst      : "parallax serial terminal"
  FBS      : "FeedBackServo"
  
PUB main              
  pst.Start (115_200)                        'start up ser terminal
  pst.str(String("hello, world   "))         'runs in cog 1
  pst.NewLine
  waitcnt(clkfreq/10+cnt)
  LastServo := 3                        'figure out how many servos to exercise
  if (CP3 == 0) and (FP3 == 0)          'by looking at which servos have valid
     LastServo := 2                     'pins numbers
  if (CP2 == 0) and (FP2 == 0)
    LastServo := 1
  if (CP1 == 0) and (FP1 == 0)
    LastServo := 0
    
  cog := FBS.start(CP0,FP0, CP1,FP1, CP2,FP2, CP3,FP3)   'specify pin numbers   
  pst.str(string("Started PASM cog: "))       '0,0 pin numbers says no servo
  pst.dec(cog)
  pst.newline
  waitcnt(clkfreq/2+cnt)          'allow time for it to start
  
  pst.str(string("Setting the DeadZone value(s) for my specific Servo(s)"))
  pst.newline
  pst.str(string("Your values will almost certainly vary"))
  pst.newline
  pst.str(string("The default is 31"))
  pst.newline
  FBS.setDeltaMin(servo0, 24)
  if (LastServo > 0)
    FBS.setDeltaMin(servo1, 33)
  if (LastServo > 1)
    FBS.setDeltaMin(servo2, 25)
  if (LastServo > 2)  
    FBS.setDeltaMin(servo3, 33)

        
    
  pst.newline
  pst.str(string("Demo Fixed Pulse Width Mode"))
  pst.newline
  pst.str(string("Hit any key to begin or stop"))
  repeat until pst.rxcount <> 0
  pst.char(pst.charin)
  pst.newline   
  repeat theservo from 0 to LastServo     'constant pulse width
    FBS.width(theservo, (1470))
  repeat until pst.rxCount <> 0
    repeat theservo from 0 to LastServo
      pst.str(string("   Servo"))
      pst.dec(theServo)
      pst.str(string(" Theta: "))
      dispThree(FBS.GetPos(TheServo))
      pst.str(string(" RPM: "))
      dispThree(FBS.GetVelocity(TheServo))
      waitcnt(clkfreq/10 + cnt)
    pst.newline   
  repeat theservo from 0 to LastServo
    FBS.width(theservo, 1500)             'stop them all  
  pst.char(pst.charin)                    'clear the in buffer    
 
  pst.newline
  pst.str(string("Demo Constant Velocity Mode"))
  pst.newline
  pst.str(string("Displays the actual pulse width sent to the servo"))
  pst.newline
  pst.str(string("As you increase the load,"))
  pst.newline
  pst.str(string("Observe that the pulse width deviates furthur from 1500"))
  pst.newline
  pst.str(string("Hit any key to begin or stop"))
  repeat until pst.rxcount <> 0
  pst.char(pst.charin)
  FBS.SetVelocity(servo0, 20, CW)
  if LastServo > 0
    FBS.SetVelocity(servo1, 25, CW)
  if LastServo > 1  
    FBS.SetVelocity(servo2, 30, CCW)
  if LastServo > 2  
    FBS.SetVelocity(servo3, 35, CCW)  
  repeat until pst.rxCount <> 0
    repeat theservo from 0 to lastservo
      pst.str(string("     PW: "))
      pst.dec(FBS.GetPulseWidth(theservo))
      pst.str(string(" RPM: "))
      dispThree(FBS.GetVelocity(theservo))
    waitcnt(clkfreq/10 + cnt)
    pst.newline
  repeat theservo from 0 to lastservo
    FBS.Width(theservo, 1500)          'stop the servo  
  pst.char(pst.charin)

  pst.newline
  pst.str(string("Execute set position.  Full Scale Changes"))
  pst.newline
  pst.str(string("If a servo gets stuck, you can change SetDeltaMin()"))
  pst.newline
  pst.str(string("If a servo oscillates, you can change SetGain() or SetMaxError()"))
  pst.newline
  pst.str(string("Hit any key to begin"))
  repeat until pst.rxcount <> 0
  pst.char(pst.charin)    
  repeat theservo from 0 to LastServo     'full scale changes
    pst.str(string("Servo: "))
    pst.dec(theservo)
    repeat angle from 0 to 3              'four cases
      commanded := lookupz(angle: 180, 0, 359, 0)
      pst.char(" ")
      pst.str(string("Cmnd: "))
      pst.dec(Commanded)                           'show commanded angle
      FBS.SetPos(theservo, Commanded)              'set it
      waitcnt(clkfreq/100+cnt)
      repeat while FBS.CheckDone(theservo) <> 0    'await completion
      pst.str(string("  Final: "))
      pst.dec(FBS.GetPos(theServo))
      pst.str(string("   "))
    pst.newline           

  pst.newline
  pst.newline
  pst.str(string("Drive all servos with random position commands"))
  pst.newline
  pst.str(string("If a servo gets stuck, you can change SetDeltaMin()"))
  pst.newline
  pst.str(string("If a servo oscillates, you can change SetGain() or SetMaxError()"))
  pst.newline
  pst.str(string("Hit any key to begin or stop"))
  repeat until pst.rxcount <> 0
  pst.char(pst.charin)
  pst.newline
  rcount := 0                                  'all four with random movements
  random := cnt                               'seed
  repeat until pst.rxCount <> 0
     repeat currentservo from 0 to lastservo
       if fbs.checkdone(currentservo) == 0     'issue command to whichever is done
          pst.newline
          pst.dec(currentservo)               'number
          pst.str(string("  Commanded: "))
          dispThree(cmnded[currentservo])
          pst.str(string("  Actual: "))
          dispThree(FBS.getpos(currentservo))
          pst.str(string("  Error: "))
          dispThree(cmnded[currentservo] - FBS.getpos(currentservo)) 
          ?random
          commanded := || random           'drop sign bit
          commanded := (commanded // 360)    'range 0..359        
          FBS.SetPos(currentservo,commanded)
          cmnded[currentservo] := commanded
          pst.str(string("   "))
          pst.dec(rcount++)
  pst.char(pst.charin)             

  pst.newline
  pst.newline
  pst.str(string("Now a combination of commands"))
  pst.newline
  pst.str(string("Servo0 constant velocity of 20 RPM CW"))
  pst.newline
  pst.str(string("Servo1 constant velocity of 20 RPM CCW (faces other side)"))
  pst.newline
  pst.str(string("Servo2 slowly scans from 90 degrees to 270 degees"))
  pst.newline
  pst.str(string("Servo3 sometimes quickly rotates to match servo2 position"))
  pst.newline
  pst.str(string("Hit any key to begin or stop"))
  repeat until pst.rxcount <> 0
  pst.char(pst.charin)
  pst.newline
  FBS.SetVelocity(Servo0, 20, CW)         'servo zero
  if LastServo > 0
    FBS.SetVelocity(Servo1, 20, CCW)
  if LastServo > 1
    FBS.SetPos(Servo2, 90)                     'pre-position servo 2
    repeat while FBS.CheckDone(Servo2) <> 0    'await completion
  if LastServo > 2
    FBS.SetPos(servo3, 90)                     'also servo 3
    repeat while FBS.CheckDone(Servo3) <> 0    'await completion
  Servo2Theta := 90              
  repeat until pst.rxCount <> 0                'now do pretty much forever
    pst.newline
    pst.str(string("Servo0 RPM: "))
    dispThree(FBS.getvelocity(servo0))
    pst.str(string("   Servo1 RPM: "))
    dispThree(FBS.getVelocity(servo1))   
    waitcnt(clkfreq + cnt)                     'once every second    
    if LastServo == 3                          'make sure we have servos
      pst.str(string("   Servo2 Position: "))    'report current angles
      dispThree(FBS.GetPos(servo2))
      pst.str(string("   Servo3 Position: "))
      dispThree(FBS.GetPos(servo3))
      Scan2_3                                  'go move them
  FBS.Width(servo0, 1500)                      'stop them all
  FBS.Width(servo1, 1500)
  pst.char(pst.charin)   

  pst.newline
  pst.newline
  pst.str(string("Now each servo ramps from 10 rpm to 100 CW rpm and back to stopped"))
  pst.newline
  pst.str(string("Then each ramps from 10 to 100 CCW and backed to stopped"))
  pst.newline
  pst.str(string("Hit any key to begin"))
  repeat until pst.rxcount <> 0
  pst.char(pst.charin)
  pst.newline
  repeat commanded from 10 to 100 step 5
    repeat theservo from 0 to lastservo
      fbs.setvelocity(theservo, commanded, CW)
    waitcnt(clkfreq*3 + cnt)                  'allow time to ramp up
    pst.newline
    pst.dec(Commanded)
    pst.str(string("  "))
    repeat currentservo from 0 to lastservo
      pst.dec(theservo)
      pst.char(" ")
      pst.dec(fbs.getvelocity(currentservo))
      pst.str(string("   "))
      
  repeat commanded from 100 to 10 step 5
    repeat theservo from 0 to lastservo
      fbs.setvelocity(theservo, commanded, CW)
    waitcnt(clkfreq*3 + cnt)                  'allow time to ramp up
    pst.newline
    pst.dec(Commanded)
    pst.str(string("  "))
    repeat currentservo from 0 to lastservo
      pst.dec(theservo)
      pst.char(" ")
      pst.dec(fbs.getvelocity(currentservo))
      pst.str(string("   "))      
  repeat theservo from 0 to lastservo
    fbs.width(theservo, 1500)    
  pst.newline
  repeat commanded from 10 to 100 step 5
    repeat theservo from 0 to lastservo
      fbs.setvelocity(theservo, commanded, CCW)
    waitcnt(clkfreq*3 + cnt)                  'allow time to ramp up
    pst.newline
    pst.dec(Commanded)
    pst.str(string("  "))
    repeat currentservo from 0 to lastservo
      pst.dec(theservo)
      pst.char(" ")
      pst.dec(fbs.getvelocity(currentservo))
      pst.str(string("   "))
      
  repeat commanded from 100 to 10 step 5
    repeat theservo from 0 to lastservo
      fbs.setvelocity(theservo, commanded, CCW)
    waitcnt(clkfreq*3 + cnt)                  'allow time to ramp up
    pst.newline
    pst.dec(Commanded)
    pst.str(string("  "))
    repeat currentservo from 0 to lastservo
      pst.dec(theservo)
      pst.char(" ")
      pst.dec(fbs.getvelocity(currentservo))
      pst.str(string("   "))      
  repeat theservo from 0 to lastservo
    fbs.width(theservo, 1500)       
  pst.newline
  pst.str(string("all done!"))
  repeat                                       'and stop here 

  
PUB Scan2_3            
    if Servo2Theta == 270
      Servo2Theta := 85
    repeat while FBS.CheckDone(servo2) <> 0  'wait for previous to complete if needful
    FBS.SetPos(servo2, Servo2Theta+=5)       '5 degree steps
    random?                                  'roll the dice
    if ((|| random) // 10) == 0              'ten-sided
      repeat while FBS.CheckDone(servo3) <> 0
      FBS.SetPos(servo3, Servo2Theta)        'move servo 3 to servo2 position

PUB DispThree(value)
    if (Value & $8000_0000) <> 0      'negative number case
      if (|| value < 10)
         pst.char(" ")
      pst.dec(value)
    else
      if (Value < 100)
        pst.char(" ")
      if (Value < 10)
        pst.char(" ")
      pst.dec(value)                   
 '   
        
         
  


              
                   